﻿IF EXISTS (SELECT 1 FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'SafeBagScanned' AND COLUMN_NAME = 'BusinessProcessID')
	AND NOT EXISTS (SELECT 1 FROM INFORMATION_SCHEMA.CONSTRAINT_TABLE_USAGE WHERE TABLE_NAME = 'SafeBagScanned' AND CONSTRAINT_NAME = 'FK_SafeBagScanned_BusinessProcessID')
BEGIN 
PRINT 'Creating foreign key FK_SafeBagScanned_BusinessProcessID on table SafeBagScanned'
ALTER TABLE [dbo].[SafeBagScanned]  WITH CHECK ADD  CONSTRAINT [FK_SafeBagScanned_BusinessProcessID] FOREIGN KEY([BusinessProcessID])
REFERENCES [BusinessProcess] ([ID])
END
GO

IF EXISTS (SELECT 1 FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'SafeBagScanned' AND COLUMN_NAME = 'SafeBagsID')
	AND NOT EXISTS (SELECT 1 FROM INFORMATION_SCHEMA.CONSTRAINT_TABLE_USAGE WHERE TABLE_NAME = 'SafeBagScanned' AND CONSTRAINT_NAME = 'FK_SafeBagScanned_SafeBagsID')
BEGIN 
PRINT 'Creating foreign key FK_SafeBagScanned_SafeBagsID on table SafeBagScanned'
ALTER TABLE [dbo].[SafeBagScanned]  WITH CHECK ADD  CONSTRAINT [FK_SafeBagScanned_SafeBagsID] FOREIGN KEY([SafeBagsID])
REFERENCES [SafeBags] ([ID])
END
GO

IF EXISTS (SELECT 1 FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'SafeBagScanned' AND COLUMN_NAME = 'SafePeriodID')
	AND NOT EXISTS (SELECT 1 FROM INFORMATION_SCHEMA.CONSTRAINT_TABLE_USAGE WHERE TABLE_NAME = 'SafeBagScanned' AND CONSTRAINT_NAME = 'FK_SafeBagScanned_SafePeriodID')
BEGIN 
PRINT 'Creating foreign key FK_SafeBagScanned_SafePeriodID on table SafeBagScanned'
ALTER TABLE [dbo].[SafeBagScanned]  WITH CHECK ADD  CONSTRAINT [FK_SafeBagScanned_SafePeriodID] FOREIGN KEY([SafePeriodID])
REFERENCES [Safe] ([PeriodID])
END
GO

IF NOT EXISTS (SELECT 1 FROM sys.indexes WHERE object_id = OBJECT_ID(N'[dbo].[SafeBagScanned]') AND name = N'IDX_SafeBagScanned_1')
BEGIN 
PRINT 'Creating index IDX_SafeBagScanned_1 on table SafeBagScanned'
CREATE UNIQUE NONCLUSTERED INDEX [IDX_SafeBagScanned_1] ON [dbo].[SafeBagScanned] 
(
	[BusinessProcessID] ASC,
	[SafePeriodID] ASC,
	[SafeBagsID] ASC,
	[SealNumber] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
END
GO

